Subject: Re: [PATCH net 3/3] sched: cls_flow: fix panic on filter replace

From: John Fastabend <[email-masked]>
Date: Fri, 17 Jul 2015 14:07:33 -0700

On 15-07-17 01:38 PM, Daniel Borkmann wrote:
> The following test case causes a NULL pointer dereference in cls_flow:
> 
>   tc filter add dev foo parent 1: handle 0x1 flow hash keys dst action ok
>   tc filter replace dev foo parent 1: pref 49152 handle 0x1 \
>             flow hash keys mark action drop
> 
> To be more precise, actually two different panics are fixed, the first
> occurs because tcf_exts_init() is not called on the newly allocated
> filter when we do a replace. And the second panic uncovered after that
> happens since the arguments of list_replace_rcu() are swapped, the old
> element needs to be the first argument and the new element the second.
> 
> Fixes: 70da9f0bf999 ("net: sched: cls_flow use RCU")
> Signed-off-by: Daniel Borkmann <[email-masked]>
> ---
>  net/sched/cls_flow.c | 5 +++--
>  1 file changed, 3 insertions(+), 2 deletions(-)
> 

Thanks again, I must have missed running replace tests in these cases.

Acked-by: John Fastabend <[email-masked]>